> ## Documentation Index
> Fetch the complete documentation index at: https://docs.remapdb.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Generation Details

> Show all generation metadata along with its corresponding engines.



## OpenAPI

````yaml /openapi.json get /generations/{generation_id}
openapi: 3.0.0
info:
  title: Remapdb REST API Documentation
  description: >
    Vehicle Tuning Database API - For Tuning services and Tuners.


    Access comprehensive vehicle details, including types, manufacturers,
    models, engines, ECU and TCU info, tuning tools, dyno charts, and available
    tuning or remap stages with their performance gains.
  termsOfService: https://remapdb.com/terms
  contact:
    name: Remapdb.com
    url: https://remapdb.com
  version: '1.0'
  x-logo:
    url: https://cdn.remapdb.com/logos/remapdb-logo-default-full-light.svg
    altText: Remapdb REST API Documentation
servers:
  - url: https://api.remapdb.com/v1
security:
  - bearerAuth: []
tags:
  - name: Response and Errors
    description: >
      - API will always respond with json, content type: **application/json**.

      - Successfull response will return HTTP **2XX** ***(Success)*** response
      code.

      - Error response will return either HTTP **4XX** ***(Client Error)*** or
      HTTP **5XX** ***(Server Error)***.


      On error, API will return error object. It will contain the appropriate
      error **code** *(integer)* and a **message** *(string)*.

      The HTTP response code will be the same as the error code.


      Error Schema:

      ```json json_schema

      {
        "type": "object",
        "properties": {
          "code": {
            "type": "integer"
          },
          "message": {
            "type": "string"
          }
        }
      }

      ```


      Error Example:

      ```json http

      {
        "code": 404,
        "message": "Method doesnt exist."
      }

      ```
    x-traitTag: true
  - name: Language
    description: >
      All API methods accept custom language. It can be set via the
      **"Accept-Language"** header. Content of the header should be the code of
      the language you are requesting.


      #### Available languages:

      Code | Name

      ---------|----------
       `bg` | Bulgarian
       `da` | Danish
       `de` | German
       `en` | English **(default)**
       `es` | Spanish
       `et` | Estonian
       `fi` | Finnish
       `fr` | French
       `hr` | Croatian
       `it` | Italian
       `lt` | Lithuanian
       `lv` | Latvian
       `nb` | Norwegian Bokmål
       `nl` | Dutch
       `nn` | Norwegian Nynorsk
       `pt` | Portuguese
       `ru` | Russian
       `sv` | Swedish
       `tr` | Turkish
       `zs` | Chinese

      If no "accept-language" header is set, the API will use the default
      language - English.


      Following example shows how to set the language to Dutch (`nl`) using
      curl:

      ```json http

      curl 'https://api.remapdb.com/v1/search?query=audi' \

      --header 'Accept-Language: nl'

      ```
    x-traitTag: true
  - name: Rate Limits
    description: >
      To ensure optimal service performance and prevent abuse, this API enforces
      rate limiting.
        - Rate limits apply to all API methods.
        - Limits are tied to each API key and subscription plan and reset every minute.
        - If the rate limit is exceeded, the API will return error code **401** with the message: **“This API key has reached the time limit for this method”**.
    x-traitTag: true
  - name: Client SDKs
    description: >
      Remapdb offers OpenAPI v3 specification which can be used with any
      OpenAPI/Swagger client generator to generate your own client SDK.

      Download OpenAPI specification:
      [https://docs.remapdb.com/openapi.json](https://docs.remapdb.com/openapi.json).



      Following SDK's are automatically generated:

      Language | Link

      ----------|----------

      PHP |
      [https://github.com/remapdb-api/remapdb-php-sdk](https://github.com/remapdb-api/remapdb-php-sdk)

      JavaScript |
      [https://github.com/remapdb-api/remapdb-js-sdk](https://github.com/remapdb-api/remapdb-js-sdk)
    x-traitTag: true
  - name: Subscription
    description: >
      Most of the API methods require an active API subscription. The following
      method allows you to obtain information about your current API
      subscription.


      More info about Remapdb's API subscription can be found here:
      [https://app.remapdb.com/api](https://app.remapdb.com/api)
    x-displayName: API Subscription
  - name: Types
    description: >
      Obtain information about the vehicle types. 


      **Active API subscription required. Get it here:
      [https://app.remapdb.com/api](https://app.remapdb.com/api)**
    x-displayName: Vehicle Types
  - name: Manufacturers
    description: >
      Obtain information about vehicle manufacturers. 


      **Active API subscription required. Get it here:
      [https://app.remapdb.com/api](https://app.remapdb.com/api)**
  - name: Models
    description: >
      Obtain information about vehicle models. 


      **Active API subscription required. Get it here:
      [https://app.remapdb.com/api](https://app.remapdb.com/api)**
  - name: Generations
    description: >
      Obtain information about model generations. 


      **Active API subscription required. Get it here:
      [https://app.remapdb.com/api](https://app.remapdb.com/api)**      
  - name: Engines
    description: >
      Obtain information about vehicle engines. 


      **Active API subscription required. Get it here:
      [https://app.remapdb.com/api](https://app.remapdb.com/api)**     
  - name: Search
    description: >
      Searches through manufacturers, models, generations and engines. 


      **Active API subscription required. Get it here:
      [https://app.remapdb.com/api](https://app.remapdb.com/api)**
paths:
  /generations/{generation_id}:
    get:
      tags:
        - Generations
      summary: Generation Details
      description: Show all generation metadata along with its corresponding engines.
      operationId: get_generation
      parameters:
        - name: generation_id
          in: path
          description: Generation ID.
          required: true
          style: simple
          explode: false
          schema:
            type: integer
            minimum: 1
            maximum: 2147483647
            format: int32
          example: 123
        - $ref: '#/components/parameters/language'
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/generation_w_engines'
              examples:
                Successful response:
                  value:
                    id: 123
                    name: B5
                    slug: b5
                    year: 1994
                    year_end: 2001
                    photo: >-
                      https://cdn.remapdb.com/api/generations/audi_a4_b5_31pynyoby3ok0.jpg
                    type:
                      id: 1
                      name: Cars & LCV
                    manufacturer:
                      id: 1234
                      name: Audi
                    model:
                      id: 123
                      name: A4
                    engines:
                      - id: 1234
                        name: 1.8i 125hp 170Nm
                        slug: 1-8i-125hp-170nm
                        engine_code: XYZ
                        year: 2018
                        capacity: 1800
                        cylinders: 4
                        engine_type: Petrol
                        fuel: Petrol
                        ecus:
                          - name: EDC17CP54
                            manufacturer: Bosch
                        tcus:
                          - name: 8HP
                            manufacturer: ZF
                        performance:
                          power: 150
                          torque: 270
                          dyno_values:
                            rpm:
                              - 1000
                              - 2000
                              - 3000
                              - 4000
                              - 5000
                              - 6000
                              - 7000
                              - 8000
                              - 9000
                            hp:
                              - 0
                              - 49
                              - 87
                              - 112
                              - 135
                              - 140
                              - 112
                              - 0
                              - 0
                            nm:
                              - 0
                              - 238
                              - 243
                              - 238
                              - 233
                              - 205
                              - 150
                              - 0
                              - 0
                      - id: 5678
                        name: 1.8T 150hp 210Nm
                        slug: 1-8t-150hp-210nm
                        engine_code: AGU
                        capacity: 1781
                        cylinders: 4
                        engine_type: Turbo Petrol
                        fuel: Petrol
                        ecus:
                          - manufacturer: Bosch
                            name: M3.8.3
                          - manufacturer: Bosch
                            name: ME7.5
                        tcus: []
                        performance:
                          power: 150
                          torque: 210
                          dyno_values:
                            rpm:
                              - 1000
                              - 2000
                              - 3000
                              - 4000
                              - 5000
                              - 6000
                              - 7000
                              - 8000
                              - 9000
                            hp:
                              - 0
                              - 53
                              - 93
                              - 120
                              - 144
                              - 150
                              - 120
                              - 0
                              - 0
                            nm:
                              - 0
                              - 200
                              - 204
                              - 200
                              - 196
                              - 173
                              - 126
                              - 0
                              - 0
        '400':
          $ref: '#/components/responses/error_400'
        '401':
          $ref: '#/components/responses/error_401'
        '403':
          $ref: '#/components/responses/error_403'
        '404':
          $ref: '#/components/responses/error_404'
        '406':
          $ref: '#/components/responses/error_406'
        '429':
          $ref: '#/components/responses/error_429'
        '500':
          $ref: '#/components/responses/error_500'
        default:
          $ref: '#/components/responses/error_default'
      security:
        - bearerAuth: []
components:
  parameters:
    language:
      name: Accept-Language
      in: header
      description: >
        Method accept custom language. Content of the header should be the code
        of the language you are requesting. E.g.: `en`.
      required: false
      style: simple
      explode: false
      schema:
        type: string
        example: en
        enum:
          - bg
          - da
          - de
          - en
          - es
          - et
          - fi
          - fr
          - hr
          - it
          - lt
          - lv
          - nb
          - nl
          - nn
          - pt
          - ru
          - sv
          - tr
          - zs
      example: en
  schemas:
    generation_w_engines:
      additionalProperties: false
      description: Generation metadata object
      properties:
        engines:
          description: List with all the engines.
          items:
            $ref: '#/components/schemas/engine'
          maxItems: 1000
          type: array
        id:
          description: Generation ID.
          example: 123
          type: integer
        manufacturer:
          $ref: '#/components/schemas/manufacturer_short'
        model:
          $ref: '#/components/schemas/model_short'
        name:
          description: Generation Name.
          example: B5
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
        photo:
          description: Link to generations's photo.
          example: https://cdn.remapdb.com/api/generations/audi_a4_b5_31pynyoby3ok0.jpg
          maxLength: 2048
          nullable: true
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
        slug:
          description: URL-friendly name (slug).
          example: b5
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
        type:
          $ref: '#/components/schemas/vehicle_type_short'
        year:
          description: Year of manufacture.
          example: 1994
          nullable: true
          type: integer
          x-stoplight:
            id: nq06kurihg3bs
        year_end:
          description: End year of manufacture.
          example: 2001
          nullable: true
          type: integer
          x-stoplight:
            id: gsfwdd4ux320x
      title: Generation
      type: object
      x-examples:
        Example 1:
          engines:
            - capacity: 1800
              cylinders: 4
              ecus:
                - manufacturer: Bosch
                  name: EDC17CP54
              engine_code: XYZ
              engine_type: Petrol
              fuel: Petrol
              id: 1234
              name: 1.8i 125hp 170Nm
              performance:
                dyno_values:
                  hp:
                    - 0
                    - 49
                    - 87
                    - 112
                    - 135
                    - 140
                    - 112
                    - 0
                    - 0
                  nm:
                    - 0
                    - 238
                    - 243
                    - 238
                    - 233
                    - 205
                    - 150
                    - 0
                    - 0
                  rpm:
                    - 1000
                    - 2000
                    - 3000
                    - 4000
                    - 5000
                    - 6000
                    - 7000
                    - 8000
                    - 9000
                power: 150
                torque: 270
              slug: 1-8i-125hp-170nm
              tcus:
                - manufacturer: ZF
                  name: 8HP
              year: 2018
          id: 123
          manufacturer:
            id: 1234
            name: Audi
          model:
            id: 123
            name: A4
          name: B5
          photo: https://cdn.remapdb.com/api/generations/audi_a4_b5_31pynyoby3ok0.jpg
          slug: b5
          type:
            id: 1
            name: Cars & LCV
          year: 1994
          year_end: 2001
    engine:
      additionalProperties: false
      description: Engine object
      properties:
        capacity:
          description: Engine capacity in cubic cm.
          example: 1800
          nullable: true
          type: integer
          x-stoplight:
            id: gouznp0op64ai
        cylinders:
          description: Number of cylinders.
          example: 4
          nullable: true
          type: integer
          x-stoplight:
            id: d6iwr8cyyq6em
        ecus:
          description: List of ECU's used in this engine.
          items:
            $ref: '#/components/schemas/engine_ecu'
          maxItems: 1000
          type: array
          x-stoplight:
            id: migbki7dibp3a
        engine_code:
          description: Engine code.
          example: XYZ
          maxLength: 2048
          nullable: true
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
          x-stoplight:
            id: wckxngr81mqgw
        engine_type:
          description: Engine type.
          example: Petrol
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
          x-stoplight:
            id: vjc6vjrlmkyxf
        fuel:
          description: Name of the fuel.
          example: Petrol
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
          x-stoplight:
            id: f4hegp9kjeer3
        id:
          description: Engine ID.
          example: 1234
          type: integer
        name:
          description: Engine name.
          example: 1.8i 125hp 170Nm
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
          x-stoplight:
            id: luat02qipmx4j
        performance:
          $ref: '#/components/schemas/engine_performance'
        slug:
          description: URL-friendly name (slug).
          example: 1-8i-125hp-170nm
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
          x-stoplight:
            id: honjea79phwgo
        tcus:
          description: List of TCU's used in this engine.
          items:
            $ref: '#/components/schemas/engine_tcu'
          maxItems: 1000
          type: array
          x-stoplight:
            id: vn78hxdi5oged
        year:
          description: Year of manufacture.
          example: 2018
          nullable: true
          type: integer
          x-stoplight:
            id: zaj0ws6i34xwa
      title: Engine
      type: object
      x-examples:
        Example 1:
          capacity: 1800
          cylinders: 4
          ecus:
            - manufacturer: Bosch
              name: EDC17CP54
          engine_code: XYZ
          engine_type: Petrol
          fuel: Petrol
          id: 1234
          name: 1.8i 125hp 170Nm
          performance:
            dyno_values:
              hp:
                - 0
                - 49
                - 87
                - 112
                - 135
                - 140
                - 112
                - 0
                - 0
              nm:
                - 0
                - 238
                - 243
                - 238
                - 233
                - 205
                - 150
                - 0
                - 0
              rpm:
                - 1000
                - 2000
                - 3000
                - 4000
                - 5000
                - 6000
                - 7000
                - 8000
                - 9000
            power: 150
            torque: 270
          slug: 1-8i-125hp-170nm
          tcus:
            - manufacturer: ZF
              name: 8HP
          year: 2018
    manufacturer_short:
      additionalProperties: false
      description: Manufacturer object
      properties:
        id:
          description: Manufacturer ID.
          example: 1234
          type: integer
        name:
          description: Name of the manufacturer.
          example: Audi
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
      title: Manufacturer
      type: object
      x-examples:
        Audi:
          id: 1000
          name: Audi
    model_short:
      additionalProperties: false
      description: Model object
      properties:
        id:
          description: Model ID.
          example: 123
          type: integer
        name:
          description: Name of the model.
          example: A4
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
      title: Model
      type: object
      x-examples:
        Audi A4:
          id: 123
          name: A4
    vehicle_type_short:
      additionalProperties: false
      description: Vehicle type object
      properties:
        id:
          description: Vehicle type ID.
          example: 1
          type: integer
        name:
          description: Name.
          example: Cars & LCV
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
      title: Vehicle type
      type: object
      x-examples:
        Cars:
          id: 1
          name: Cars & LCV
    error:
      additionalProperties: false
      description: Error object
      properties:
        code:
          description: >-
            Error code. Typically it will be the same as the returtned HTTP
            response code.
          example: 404
          type: integer
        message:
          description: Error message.
          example: Not found
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
          x-stoplight:
            id: iaxsxsm0kqi9n
      title: Error
      type: object
      x-examples:
        Bad Request:
          code: 400
          message: Bad request / Malformed parameter
        Internal Server Error:
          code: 500
          message: Internal Server Error
        Invalid API key:
          code: 403
          message: Invalid API key
        Method Not Found:
          code: 404
          message: Method not found
        No API Access:
          code: 401
          message: API access is not enabled for this subscription
        No active subscription:
          code: 401
          message: This method requires an active subscription.
        No permissions:
          code: 401
          message: This API key does not have enough permissions
    engine_ecu:
      additionalProperties: false
      description: ECU object
      properties:
        manufacturer:
          description: Manufacturer.
          example: Bosch
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
          x-stoplight:
            id: ego5g0wgjbx5z
        name:
          description: Name.
          example: EDC17CP54
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
      title: ECU
      type: object
      x-examples:
        Bosch EDC17:
          manufacturer: Bosch
          name: EDC17CP54
    engine_performance:
      additionalProperties: false
      description: Engine performance object
      properties:
        dyno_values:
          $ref: '#/components/schemas/engine_performance_dyno'
        power:
          description: Horse power (metric).
          example: 150
          type: integer
        torque:
          description: Torque in Nm.
          example: 270
          type: integer
          x-stoplight:
            id: 6gjau8yp073kc
      title: Performance
      type: object
      x-examples:
        Example 1:
          dyno_values:
            hp:
              - 0
              - 49
              - 87
              - 112
              - 135
              - 140
              - 112
              - 0
              - 0
            nm:
              - 0
              - 238
              - 243
              - 238
              - 233
              - 205
              - 150
              - 0
              - 0
            rpm:
              - 1000
              - 2000
              - 3000
              - 4000
              - 5000
              - 6000
              - 7000
              - 8000
              - 9000
          power: 150
          torque: 270
    engine_tcu:
      additionalProperties: false
      description: TCU object
      properties:
        manufacturer:
          description: Manufacturer.
          example: ZF
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
        name:
          description: Name.
          example: 8HP
          maxLength: 2048
          pattern: ^[^\u0000-\u001F\u007F]*$
          type: string
      title: TCU
      type: object
      x-examples:
        ZF 8HP:
          manufacturer: ZF
          name: 8HP
    engine_performance_dyno:
      additionalProperties: false
      description: Dyno object
      nullable: true
      properties:
        hp:
          description: HP values for plotting a dyno chart.
          items:
            type: integer
            x-stoplight:
              id: p93ihoykl0ya1
          maxItems: 1000
          type: array
          x-stoplight:
            id: vd6hysqxr0wx8
        nm:
          description: Nm values for plotting a dyno chart.
          items:
            type: integer
            x-stoplight:
              id: 6fkv9wbg7h04g
          maxItems: 1000
          type: array
          x-stoplight:
            id: 4jpbgqaf9x9yh
        rpm:
          description: RPM values for plotting a dyno chart.
          items:
            type: integer
            x-stoplight:
              id: wlvp55ibfn59e
          maxItems: 1000
          type: array
      title: Dyno metadata
      type: object
      x-examples:
        Example 1:
          hp:
            - 0
            - 49
            - 87
            - 112
            - 135
            - 140
            - 112
            - 0
            - 0
          nm:
            - 0
            - 238
            - 243
            - 238
            - 233
            - 205
            - 150
            - 0
            - 0
          rpm:
            - 1000
            - 2000
            - 3000
            - 4000
            - 5000
            - 6000
            - 7000
            - 8000
            - 9000
  responses:
    error_400:
      description: Bad/Malformed Request
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          examples:
            Bad Request:
              value:
                code: 400
                message: Bad request / Malformed parameter
            Other:
              value:
                code: 400
                message: Other malformed request or bad parameter
    error_401:
      description: Request is unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          examples:
            No API access:
              value:
                code: 401
                message: API access is not enabled for this subscription.
            No enough permissions:
              value:
                code: 401
                message: This API key does not have enough permissions
            No active subscription:
              value:
                code: 401
                message: This method requires an active subscription.
            Other:
              value:
                code: 401
                message: Request unauthorized
    error_403:
      description: Request forbidden
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          examples:
            Invalid API key:
              value:
                code: 403
                message: Invalid API key
            Other:
              value:
                code: 403
                message: Request is forbidden
    error_404:
      description: Not Found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          examples:
            Not found:
              value:
                code: 404
                message: Not found
    error_406:
      description: Not Acceptable
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          examples:
            Not Acceptable:
              value:
                code: 406
                message: Requested response format is not acceptable
    error_429:
      description: Too Many Requests
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          examples:
            Rate limit exceeded:
              value:
                code: 429
                message: Too many requests
    error_500:
      description: Server Error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          examples:
            Server Error:
              value:
                code: 500
                message: Internal Server Error
    error_default:
      description: Unexpected error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          examples:
            Unexpected:
              value:
                code: 500
                message: Unexpected error
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: API Key
      description: |-
        All API methods require Bearer authentication.
        Use your existing API key as the bearer token.

        Authorization header format: `Authorization: Bearer YOUR_API_KEY`.

````